/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: DisplayApplication 
	Configuration 	: DefaultConfig
	Model Element	: TemperatureReaderListener
//!	Generated Date	: Tue, 4, Jul 2017  
	File Path	: DisplayApplication\DefaultConfig\TemperatureReaderListener.cpp
*********************************************************************/

//## auto_generated
#include "TemperatureReaderListener.h"
//## package DisplayPkg

//## class TemperatureReaderListener
TemperatureReaderListener::TemperatureReaderListener() {
}

TemperatureReaderListener::~TemperatureReaderListener() {
}

void TemperatureReaderListener::on_data_available(DDS::DataReader* reader) {
    //#[ operation on_data_available(DataReader)
    TemperatureTopicStructDataReader* temperatureReader = dynamic_cast<TemperatureTopicStructDataReader*>(reader);   
    
    if (temperatureReader != NULL)
    {
    	DDS::SampleInfo info;
    	DDS::ReturnCode_t retcode;
    	TemperatureTopicStruct temperatureStruct;
    	
    	for(;;)
    	{
    		TemperatureTopicStruct_initialize(&temperatureStruct);
    		retcode = temperatureReader->take_next_sample(temperatureStruct, info);				
    		if (retcode == DDS::RETCODE_NO_DATA)
    		{
    			break;
    		} 
    		else if (retcode != DDS::RETCODE_OK) 
    		{
    			printf("take_next_sample returned error %d\n", retcode);
                return;		
       		}
       		if (info.valid_data)
       		{   			
    			printf("Time: %f \t Temperature %f\n", temperatureStruct.timestamp, temperatureStruct.temperature);
       		}
       		TemperatureTopicStruct_finalize(&temperatureStruct);
       	}	
    }
    //#]
}

void TemperatureReaderListener::on_liveliness_changed(DDS::DataReader* reader, const DDS::LivelinessChangedStatus& status) {
    //#[ operation on_liveliness_changed(DataReader,LivelinessChangedStatus)
    //#]
}

void TemperatureReaderListener::on_requested_deadline_missed(DDS::DataReader* reader, const DDS::RequestedDeadlineMissedStatus& status) {
    //#[ operation on_requested_deadline_missed(DataReader,RequestedDeadlineMissedStatus)
    //#]
}

void TemperatureReaderListener::on_requested_incompatible_qos(DDS::DataReader* reader, const DDS::RequestedIncompatibleQosStatus& status) {
    //#[ operation on_requested_incompatible_qos(DataReader,RequestedIncompatibleQosStatus)
    //#]
}

void TemperatureReaderListener::on_sample_lost(DDS::DataReader* reader, const DDS::SampleLostStatus& status) {
    //#[ operation on_sample_lost(DataReader,SampleLostStatus)
    //#]
}

void TemperatureReaderListener::on_sample_rejected(DDS::DataReader* reader, const DDS::SampleRejectedStatus& status) {
    //#[ operation on_sample_rejected(DataReader,SampleRejectedStatus)
    //#]
}

void TemperatureReaderListener::on_subscription_matched(DDS::DataReader* reader, const DDS::SubscriptionMatchedStatus& status) {
    //#[ operation on_subscription_matched(DataReader,SubscriptionMatchedStatus)
    //#]
}

/*********************************************************************
	File Path	: DisplayApplication\DefaultConfig\TemperatureReaderListener.cpp
*********************************************************************/
