/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: TemperatureInsideApplication 
	Configuration 	: DefaultConfig
	Model Element	: ThermometerInside
//!	Generated Date	: Tue, 4, Jul 2017  
	File Path	: TemperatureInsideApplication\DefaultConfig\ThermometerInside.cpp
*********************************************************************/

//## auto_generated
#include "ThermometerInside.h"
//## operation publishThermometerInsideWriter(TemperatureTopicStruct)
#include "TemperaturePkg_IDL.h"
//## auto_generated
#include "stdio.h"
//##   ignore
#include "MainTemperatureInsideApplication.h"
//## attribute ThermometerInsideWriter
#include "TemperaturePkg_IDLSupport.h"
//## package ThermometerInside

//## class ThermometerInside
ThermometerInside::ThermometerInside() {
    initPublisher();
}

ThermometerInside::~ThermometerInside() {
    cleanupPublisher();
}

DDS::ReturnCode_t ThermometerInside::publishThermometerInsideWriter(const TemperatureTopicStruct& data) {
    //#[ operation publishThermometerInsideWriter(TemperatureTopicStruct)
    return ThermometerInsideWriter->write(data, DDS::HANDLE_NIL);
    //#]
}

TemperatureTopicStructDataWriter* ThermometerInside::getThermometerInsideWriter() const {
    return ThermometerInsideWriter;
}

void ThermometerInside::setThermometerInsideWriter(TemperatureTopicStructDataWriter * p_ThermometerInsideWriter) {
    ThermometerInsideWriter = p_ThermometerInsideWriter;
}

void ThermometerInside::publishOne() {
    //#[ operation publishOne()
    DDS_Duration_t receive_period = {1,0};
    for (int i=0; i<10; i++) {
    	TemperatureTopicStruct myTemperature;
    	myTemperature.temperature = 5.3;
    	myTemperature.timestamp = 1.0;
    
    	DDS::ReturnCode_t returncode = publishThermometerInsideWriter(myTemperature);
    
    	std::cout << "ReturnCode: " << returncode << std::endl;
    	std::cout << "Time: " << myTemperature.timestamp << "\t Temperature: " << myTemperature.temperature << std::endl;
    	
    	NDDSUtility::sleep(receive_period);
    }
    
    //#]
}

//#[ ignore
DDS::Publisher* ThermometerInside::getPublisher() {
    return publisher;
}

void ThermometerInside::initPublisher() {
    DDS::DomainParticipant* domainParticipant = TemperatureInsideApplicationDP::instance()->getDomainParticipant();
    if (domainParticipant != NULL)
    {
    	publisher = domainParticipant->create_publisher(DDS::PUBLISHER_QOS_DEFAULT, NULL, 0);
    	if (publisher != NULL)
    	{
    		DDS::Topic* TemperatureTopicTopic = dynamic_cast<DDS::Topic*>(TemperatureInsideApplicationDP::instance()->lookupTopicDescription("TemperatureTopic"));
    		if (TemperatureTopicTopic!= NULL)
    		{
    			DDS::DataWriter* dataWriter = publisher->create_datawriter(TemperatureTopicTopic, DDS::DATAWRITER_QOS_DEFAULT, NULL, 0);
    			ThermometerInsideWriter = dynamic_cast<TemperatureTopicStructDataWriter*>(dataWriter);		
    		}
    	}
    }
}

void ThermometerInside::cleanupPublisher() {
    if (publisher != NULL) 
    {
    	publisher->delete_contained_entities();
    	DDS::DomainParticipant* domainParticipant = publisher->get_participant();
    	domainParticipant->delete_publisher(publisher);
    	publisher = NULL;
    }
}
//#]

/*********************************************************************
	File Path	: TemperatureInsideApplication\DefaultConfig\ThermometerInside.cpp
*********************************************************************/
