/********************************************************************
	Rhapsody	: 8.2.1 
	Login		: fandras
	Component	: ThermometerOutside 
	Configuration 	: DefaultConfig
	Model Element	: ThermometerOutsidePublisher
//!	Generated Date	: Wed, 5, Jul 2017  
	File Path	: ThermometerOutside\DefaultConfig\ThermometerOutsidePublisher.cpp
*********************************************************************/

//## auto_generated
#include "ThermometerOutsidePublisher.h"
//## operation publishThermometerOutsideWriter(TemperatureTopicStruct)
#include "TemperaturePkg_IDL.h"
//##   ignore
#include "MainThermometerOutside.h"
//## attribute ThermometerOutsideWriter
#include "TemperaturePkg_IDLSupport.h"
//## package ThermometerOutside

//## class ThermometerOutsidePublisher
ThermometerOutsidePublisher::ThermometerOutsidePublisher() {
    initPublisher();
}

ThermometerOutsidePublisher::~ThermometerOutsidePublisher() {
    cleanupPublisher();
}

void ThermometerOutsidePublisher::publishOne() {
    //#[ operation publishOne()
    DDS_Duration_t receive_period = {1,0};
    for (int i=0; i<10; i++) {
    	TemperatureTopicStruct myTemperature;
    	myTemperature.temperature = 7.3;
    	myTemperature.timestamp = 2.0;
    
    	DDS::ReturnCode_t returncode = publishThermometerOutsideWriter(myTemperature);
    
    	std::cout << "ReturnCode: " << returncode << std::endl;
    	std::cout << "Time: " << myTemperature.timestamp << "\t Temperature: " << myTemperature.temperature << std::endl;
    
    	NDDSUtility::sleep(receive_period);
    }
    //#]
}

DDS::ReturnCode_t ThermometerOutsidePublisher::publishThermometerOutsideWriter(const TemperatureTopicStruct& data) {
    //#[ operation publishThermometerOutsideWriter(TemperatureTopicStruct)
    return ThermometerOutsideWriter->write(data, DDS::HANDLE_NIL);
    //#]
}

TemperatureTopicStructDataWriter* ThermometerOutsidePublisher::getThermometerOutsideWriter() const {
    return ThermometerOutsideWriter;
}

void ThermometerOutsidePublisher::setThermometerOutsideWriter(TemperatureTopicStructDataWriter * p_ThermometerOutsideWriter) {
    ThermometerOutsideWriter = p_ThermometerOutsideWriter;
}

//#[ ignore
DDS::Publisher* ThermometerOutsidePublisher::getPublisher() {
    return publisher;
}

void ThermometerOutsidePublisher::initPublisher() {
    DDS::DomainParticipant* domainParticipant = ThermometerOutsideDP::instance()->getDomainParticipant();
    if (domainParticipant != NULL)
    {
    	publisher = domainParticipant->create_publisher(DDS::PUBLISHER_QOS_DEFAULT, NULL, 0);
    	if (publisher != NULL)
    	{
    		DDS::Topic* TemperatureTopicTopic = dynamic_cast<DDS::Topic*>(ThermometerOutsideDP::instance()->lookupTopicDescription("TemperatureTopic"));
    		if (TemperatureTopicTopic!= NULL)
    		{
    			DDS::DataWriter* dataWriter = publisher->create_datawriter(TemperatureTopicTopic, DDS::DATAWRITER_QOS_DEFAULT, NULL, 0);
    			ThermometerOutsideWriter = dynamic_cast<TemperatureTopicStructDataWriter*>(dataWriter);		
    		}
    	}
    }
}

void ThermometerOutsidePublisher::cleanupPublisher() {
    if (publisher != NULL) 
    {
    	publisher->delete_contained_entities();
    	DDS::DomainParticipant* domainParticipant = publisher->get_participant();
    	domainParticipant->delete_publisher(publisher);
    	publisher = NULL;
    }
}
//#]

/*********************************************************************
	File Path	: ThermometerOutside\DefaultConfig\ThermometerOutsidePublisher.cpp
*********************************************************************/
